## xen-qemu-dm-4.0 4.0.1

=== Makefile ===
# Makefile for QEMU.

include config-host.mak
include $(SRC_PATH)/rules.mak

.PHONY: all clean cscope distclean dvi html info install install-doc \
	recurse-all speed tar tarbin test

VPATH=$(SRC_PATH):$(SRC_PATH)/hw


CFLAGS += $(OS_CFLAGS) $(ARCH_CFLAGS)
LDFLAGS += $(OS_LDFLAGS) $(ARCH_LDFLAGS)

CPPFLAGS += -I. -I$(SRC_PATH) -MMD -MP -MT $@
CPPFLAGS += -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
LIBS=
ifdef CONFIG_STATIC
LDFLAGS += -static
endif
ifdef BUILD_DOCS
DOCS=qemu-doc.html qemu-tech.html qemu.1 qemu-img.1 qemu-nbd.8
else
DOCS=
endif

LIBS+=$(AIOLIBS)

ifdef CONFIG_SOLARIS
LIBS+=-lsocket -lnsl -lresolv
endif

ifdef CONFIG_WIN32
LIBS+=-lwinmm -lws2_32 -liphlpapi
endif

all: $(TOOLS) $(DOCS) recurse-all

SUBDIR_RULES=$(patsubst %,subdir-%, $(TARGET_DIRS))

subdir-%:
	$(call quiet-command,$(MAKE) -C $* V="$(V)" TARGET_DIR="$*/" all,)

$(filter %-softmmu,$(SUBDIR_RULES)): libqemu_common.a
$(filter %-user,$(SUBDIR_RULES)): libqemu_user.a

recurse-all: $(SUBDIR_RULES)

CPPFLAGS += -I$(XEN_ROOT)/tools/libxc
CPPFLAGS += -I$(XEN_ROOT)/tools/blktap/lib
CPPFLAGS += -I$(XEN_ROOT)/tools/xenstore
CPPFLAGS += -I$(XEN_ROOT)/tools/include

tapdisk-ioemu: tapdisk-ioemu.c cutils.c block.c block-raw.c block-cow.c block-qcow.c aes.c block-vmdk.c block-cloop.c block-dmg.c block-bochs.c block-vpc.c block-vvfat.c block-qcow2.c hw/xen_blktap.c osdep.c
	$(CC) -DQEMU_TOOL $(CFLAGS) $(CPPFLAGS) $(BASE_CFLAGS) $(LDFLAGS) $(BASE_LDFLAGS) -o $@ $^ -lz $(LIBS)

#######################################################################
# BLOCK_OBJS is code used by both qemu system emulation and qemu-img

BLOCK_OBJS=cutils.o osdep.o qemu-malloc.o
BLOCK_OBJS+=block-cow.o block-qcow.o aes.o block-vmdk.o block-cloop.o
BLOCK_OBJS+=block-dmg.o block-bochs.o block-vpc.o block-vvfat.o
BLOCK_OBJS+=block-qcow2.o block-parallels.o block-nbd.o
BLOCK_OBJS+=nbd.o block.o aio.o

ifdef CONFIG_WIN32
BLOCK_OBJS += block-raw-win32.o
else
ifdef CONFIG_AIO
BLOCK_OBJS += posix-aio-compat.o
endif
BLOCK_OBJS += block-raw-posix.o
endif

######################################################################
# libqemu_common.a: Target independent part of system emulation. The
# long term path is to suppress *all* target specific code in case of
# system emulation, i.e. a single QEMU executable should support all
# CPUs and machines.

OBJS=$(BLOCK_OBJS)
OBJS+=readline.o console.o

OBJS+=irq.o
OBJS+=i2c.o smbus.o smbus_eeprom.o max7310.o max111x.o wm8750.o
OBJS+=ssd0303.o ssd0323.o ads7846.o stellaris_input.o twl92230.o
OBJS+=tmp105.o lm832x.o
OBJS+=scsi-disk.o cdrom.o
OBJS+=scsi-generic.o
OBJS+=usb.o usb-hub.o usb-$(HOST_USB).o usb-hid.o usb-msd.o usb-wacom.o
OBJS+=usb-serial.o usb-net.o
OBJS+=sd.o ssi-sd.o
OBJS+=bt.o bt-host.o bt-vhci.o bt-l2cap.o bt-sdp.o bt-hci.o bt-hid.o usb-bt.o
OBJS+=buffered_file.o migration.o migration-tcp.o net.o qemu-sockets.o
OBJS+=qemu-char.o aio.o net-checksum.o savevm.o cache-utils.o

ifdef CONFIG_BRLAPI
OBJS+= baum.o
LIBS+=-lbrlapi
endif

ifdef CONFIG_WIN32
OBJS+=tap-win32.o
else
OBJS+=migration-exec.o
endif

AUDIO_OBJS = audio.o noaudio.o wavaudio.o mixeng.o
ifdef CONFIG_SDL
AUDIO_OBJS += sdlaudio.o
endif
ifdef CONFIG_OSS
AUDIO_OBJS += ossaudio.o
endif
ifdef CONFIG_COREAUDIO
AUDIO_OBJS += coreaudio.o
AUDIO_PT = yes
endif
ifdef CONFIG_ALSA
AUDIO_OBJS += alsaaudio.o
endif
ifdef CONFIG_DSOUND
AUDIO_OBJS += dsoundaudio.o
endif
ifdef CONFIG_FMOD
AUDIO_OBJS += fmodaudio.o
audio/audio.o audio/fmodaudio.o: CPPFLAGS := -I$(CONFIG_FMOD_INC) $(CPPFLAGS)
endif
ifdef CONFIG_ESD
AUDIO_PT = yes
AUDIO_PT_INT = yes
AUDIO_OBJS += esdaudio.o
endif
ifdef CONFIG_PA
AUDIO_PT = yes
AUDIO_PT_INT = yes
AUDIO_OBJS += paaudio.o
endif
ifdef AUDIO_PT
LDFLAGS += -pthread
endif
ifdef AUDIO_PT_INT
AUDIO_OBJS += audio_pt_int.o
endif
AUDIO_OBJS+= wavcapture.o
ifdef CONFIG_AUDIO
OBJS+=$(addprefix audio/, $(AUDIO_OBJS))
endif

ifdef CONFIG_SDL
OBJS+=sdl.o x_keymap.o
endif
ifdef CONFIG_CURSES
OBJS+=curses.o
endif
OBJS+=vnc.o d3des.o

ifdef CONFIG_COCOA
OBJS+=cocoa.o
endif

ifdef CONFIG_SLIRP
CPPFLAGS+=-I$(SRC_PATH)/slirp
SLIRP_OBJS=cksum.o if.o ip_icmp.o ip_input.o ip_output.o \
slirp.o mbuf.o misc.o sbuf.o socket.o tcp_input.o tcp_output.o \
tcp_subr.o tcp_timer.o udp.o bootp.o debug.o tftp.o
OBJS+=$(addprefix slirp/, $(SLIRP_OBJS))
endif

LIBS+=$(VDE_LIBS)

cocoa.o: cocoa.m

sdl.o: sdl.c keymaps.c sdl_keysym.h

sdl.o audio/sdlaudio.o: CFLAGS += $(SDL_CFLAGS)

vnc.o: vnc.c keymaps.c sdl_keysym.h vnchextile.h d3des.c d3des.h

vnc.o: CFLAGS += $(CONFIG_VNC_TLS_CFLAGS)

curses.o: curses.c keymaps.c curses_keys.h

bt-host.o: CFLAGS += $(CONFIG_BLUEZ_CFLAGS)

libqemu_common.a: $(OBJS)

#######################################################################
# USER_OBJS is code used by qemu userspace emulation
USER_OBJS=cutils.o  cache-utils.o

libqemu_user.a: $(USER_OBJS)

######################################################################

qemu-img$(EXESUF): qemu-img.o qemu-tool.o osdep.o $(BLOCK_OBJS)

qemu-nbd$(EXESUF):  qemu-nbd.o qemu-tool.o osdep.o $(BLOCK_OBJS)

qemu-img$(EXESUF) qemu-nbd$(EXESUF): LIBS += -lz


clean:
# avoid old build problems by removing potentially incorrect old files
	rm -f config.mak config.h op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
	rm -f *.o *.d *.a $(TOOLS) TAGS cscope.* *.pod *~ */*~
	rm -f slirp/*.o slirp/*.d audio/*.o audio/*.d
	$(MAKE) -C tests clean
	for d in $(TARGET_DIRS); do \
	$(MAKE) -C $$d $@ || exit 1 ; \
        done

distclean: clean
	rm -f config-host.mak config-host.h $(DOCS)
	rm -f qemu-{doc,tech}.{info,aux,cp,dvi,fn,info,ky,log,pg,toc,tp,vr}
	for d in $(TARGET_DIRS); do \
	rm -rf $$d || exit 1 ; \
        done

KEYMAPS=da     en-gb  et  fr     fr-ch  is  lt  modifiers  no  pt-br  sv \
ar      de     en-us  fi  fr-be  hr     it  lv  nl         pl  ru     th \
common  de-ch  es     fo  fr-ca  hu     ja  mk  nl-be      pt  sl     tr

ifdef INSTALL_BLOBS
BLOBS=bios.bin vgabios.bin vgabios-cirrus.bin ppc_rom.bin \
video.x openbios-sparc32 openbios-sparc64 openbios-ppc \
pxe-ne2k_pci.bin pxe-rtl8139.bin pxe-pcnet.bin pxe-e1000.bin \
bamboo.dtb
else
BLOBS=
endif

install-doc: $(DOCS)
	mkdir -p "$(DESTDIR)$(docdir)"
	$(INSTALL) -m 644 qemu-doc.html  qemu-tech.html "$(DESTDIR)$(docdir)"
ifndef CONFIG_WIN32
	mkdir -p "$(DESTDIR)$(mandir)/man1"
	$(INSTALL) -m 644 qemu.1 qemu-img.1 "$(DESTDIR)$(mandir)/man1"
	mkdir -p "$(DESTDIR)$(mandir)/man8"
	$(INSTALL) -m 644 qemu-nbd.8 "$(DESTDIR)$(mandir)/man8"
endif

install: all $(if $(BUILD_DOCS),install-doc)
	mkdir -p "$(DESTDIR)$(bindir)"
ifneq ($(TOOLS),)
	$(INSTALL) -m 755 -s $(TOOLS) "$(DESTDIR)$(bindir)"
endif
ifneq ($(BLOBS),)
	mkdir -p "$(DESTDIR)$(datadir)"
	set -e; for x in $(BLOBS); do \
		$(INSTALL) -m 644 $(SRC_PATH)/pc-bios/$$x "$(DESTDIR)$(datadir)"; \
	done
endif
ifndef CONFIG_WIN32
	mkdir -p "$(DESTDIR)$(datadir)/keymaps"
	set -e; for x in $(KEYMAPS); do \
		$(INSTALL) -m 644 $(SRC_PATH)/keymaps/$$x "$(DESTDIR)$(datadir)/keymaps"; \
	done
endif
	for d in $(TARGET_DIRS); do \
	$(MAKE) -C $$d $@ || exit 1 ; \
        done

# various test targets
test speed: all
	$(MAKE) -C tests $@

TAGS:
	etags *.[ch] tests/*.[ch]

cscope:
	rm -f ./cscope.*
	find . -name "*.[ch]" -print | sed 's,^\./,,' > ./cscope.files
	cscope -b

# documentation
%.html: %.texi
	texi2html -monolithic -number $<

%.info: %.texi
	makeinfo $< -o $@

%.dvi: %.texi
	texi2dvi $<

qemu.1: qemu-doc.texi
	$(SRC_PATH)/texi2pod.pl $< qemu.pod
	pod2man --section=1 --center=" " --release=" " qemu.pod > $@

qemu-img.1: qemu-img.texi
	$(SRC_PATH)/texi2pod.pl $< qemu-img.pod
	pod2man --section=1 --center=" " --release=" " qemu-img.pod > $@

qemu-nbd.8: qemu-nbd.texi
	$(SRC_PATH)/texi2pod.pl $< qemu-nbd.pod
	pod2man --section=8 --center=" " --release=" " qemu-nbd.pod > $@

info: qemu-doc.info qemu-tech.info

dvi: qemu-doc.dvi qemu-tech.dvi

html: qemu-doc.html qemu-tech.html

qemu-doc.dvi qemu-doc.html qemu-doc.info: qemu-img.texi qemu-nbd.texi

VERSION ?= $(shell cat VERSION)
FILE = qemu-$(VERSION)

# tar release (use 'make -k tar' on a checkouted tree)
tar:
	rm -rf /tmp/$(FILE)
	cp -r . /tmp/$(FILE)
	cd /tmp && tar zcvf ~/$(FILE).tar.gz $(FILE) --exclude CVS --exclude .git --exclude .svn
	rm -rf /tmp/$(FILE)

# generate a binary distribution
tarbin:
	cd / && tar zcvf ~/qemu-$(VERSION)-$(ARCH).tar.gz \
	$(bindir)/qemu \
	$(bindir)/qemu-system-x86_64 \
	$(bindir)/qemu-system-arm \
	$(bindir)/qemu-system-cris \
	$(bindir)/qemu-system-m68k \
	$(bindir)/qemu-system-mips \
	$(bindir)/qemu-system-mipsel \
	$(bindir)/qemu-system-mips64 \
	$(bindir)/qemu-system-mips64el \
	$(bindir)/qemu-system-ppc \
	$(bindir)/qemu-system-ppcemb \
	$(bindir)/qemu-system-ppc64 \
	$(bindir)/qemu-system-sh4 \
	$(bindir)/qemu-system-sh4eb \
	$(bindir)/qemu-system-sparc \
	$(bindir)/qemu-i386 \
	$(bindir)/qemu-x86_64 \
	$(bindir)/qemu-alpha \
	$(bindir)/qemu-arm \
	$(bindir)/qemu-armeb \
	$(bindir)/qemu-cris \
	$(bindir)/qemu-m68k \
	$(bindir)/qemu-mips \
	$(bindir)/qemu-mipsel \
	$(bindir)/qemu-ppc \
	$(bindir)/qemu-ppc64 \
	$(bindir)/qemu-ppc64abi32 \
	$(bindir)/qemu-sh4 \
	$(bindir)/qemu-sh4eb \
	$(bindir)/qemu-sparc \
	$(bindir)/qemu-sparc64 \
	$(bindir)/qemu-sparc32plus \
	$(bindir)/qemu-img \
	$(bindir)/qemu-nbd \
	$(datadir)/bios.bin \
	$(datadir)/vgabios.bin \
	$(datadir)/vgabios-cirrus.bin \
	$(datadir)/ppc_rom.bin \
	$(datadir)/video.x \
	$(datadir)/openbios-sparc32 \
	$(datadir)/openbios-sparc64 \
	$(datadir)/openbios-ppc \
	$(datadir)/pxe-ne2k_pci.bin \
	$(datadir)/pxe-rtl8139.bin \
	$(datadir)/pxe-pcnet.bin \
	$(datadir)/pxe-e1000.bin \
	$(docdir)/qemu-doc.html \
	$(docdir)/qemu-tech.html \
	$(mandir)/man1/qemu.1 \
	$(mandir)/man1/qemu-img.1 \
	$(mandir)/man8/qemu-nbd.8

# Include automatically generated dependency files
-include $(wildcard *.d audio/*.d slirp/*.d)

=== debian/changelog ===
xen-qemu-dm-4.0 (4.0.1-2+squeeze3) stable-security; urgency=low

  * Security upload
  * Fix for Xen Security Advisory 41 (CVE-2012-6075)

 -- Guido Trotter <ultrotter@debian.org>  Wed, 06 Feb 2013 16:48:17 +0100

xen-qemu-dm-4.0 (4.0.1-2+squeeze2) stable-security; urgency=low

  * Security upload
  * Fix for Xen Security Advisory 17 (CVE-2012-3515)
  * Fix for Xen Security Advisory 19 (CVE-2012-4411) (closes: #686848)

 -- Guido Trotter <ultrotter@debian.org>  Sat, 08 Sep 2012 12:29:04 +0000

xen-qemu-dm-4.0 (4.0.1-2+squeeze1) squeeze-security; urgency=low

  * Fixes buffer underflow (CVE-2012-0029).

 -- Thomas Goirand <zigo@debian.org>  Wed, 01 Feb 2012 17:51:45 +0000

xen-qemu-dm-4.0 (4.0.1-2) unstable; urgency=low

  * Removed /usr/lib/xen symlink creation (Closes: #606592).

 -- Thomas Goirand <zigo@debian.org>  Tue, 21 Dec 2010 13:36:50 +0800

xen-qemu-dm-4.0 (4.0.1-1) unstable; urgency=low

  * New (bugfix) upstream release fixing:
    - read only file images are really read only now.
    - Revert "Wait for frontend state Connected before connecting the backend"
  * Standards-Version: to 3.9.1.
  * Added Vcs-Git: field.

 -- Thomas Goirand <zigo@debian.org>  Thu, 26 Aug 2010 16:13:12 +0800

xen-qemu-dm-4.0 (4.0.0-5) unstable; urgency=low

  * Changed Standards-Version: to 3.9.0, defined Vcs-Browser: correctly.

 -- Thomas Goirand <zigo@debian.org>  Thu, 15 Jul 2010 14:31:39 +0800

xen-qemu-dm-4.0 (4.0.0-4) unstable; urgency=low

  * Added build-dependency to libbluetooth-dev.

 -- Thomas Goirand <zigo@debian.org>  Wed, 14 Jul 2010 19:55:31 +0800

xen-qemu-dm-4.0 (4.0.0-3) unstable; urgency=low

  * Reviewed the debian/copyright, as per request from the ftp-masters.
  * Added a debian/README.source

 -- Thomas Goirand <zigo@debian.org>  Sat, 10 Jul 2010 21:39:31 +0800

xen-qemu-dm-4.0 (4.0.0-2) unstable; urgency=low

  * Changed dependency from qemu-system to qemu-system | qemu so that this
    package can be installed in Lenny.

 -- Thomas Goirand <zigo@debian.org>  Sun, 04 Jul 2010 03:12:49 +0800

xen-qemu-dm-4.0 (4.0.0-1) unstable; urgency=low

  * Initial release. (Closes: #580936)

 -- Thomas Goirand <zigo@debian.org>  Thu, 17 Dec 2009 08:56:32 +0800

=== debian/control ===
Source: xen-qemu-dm-4.0
Section: misc
Priority: optional
Maintainer: Thomas Goirand <zigo@debian.org>
Build-Depends: debhelper (>= 7), libpci-dev, libsdl-dev, libxen-dev (>= 4.0), texi2html, perl, libgnutls-dev, libasound2-dev, libesd0-dev, libpulse-dev, libbrlapi-dev, libbluetooth-dev
Standards-Version: 3.9.1
Vcs-Browser: http://git.debian.org/?p=users/zigo/xen-qemu-dm-4.0.git
Vcs-Git: http://git.debian.org/git/users/zigo/xen-qemu-dm-4.0.git
Homepage: http://www.xen.org/

Package: xen-qemu-dm-4.0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, xen-hypervisor-4.0-amd64 | xen-hypervisor-4.0-i386 | xen-hypervisor-4.0, etherboot, qemu-system | qemu
Provides: xen-qemu-dm
Description: Xen Qemu Device Model virtual machine hardware emulator
 This package is the Xen version of the Qemu emulator especially patched for
 its hypervisor. With xen-qemu-dm, you can run a fully virtualized virtual
 machine if your hardware supports it (Intel VT support, or AMD-v technology).

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKG_NAME=xen-qemu-dm-4.0
XEN_TARGET=xen-4.0
XEN_FOLDER=/usr/lib/$(XEN_TARGET)

BUILD_DIR=debian/build
STAMPS_DIR=debian/stamps

$(STAMPS_DIR)/source:
	@mkdir -p $(STAMPS_DIR)
	# Do a fresh copy of all the code in debian/build/source
	rm -rf $(BUILD_DIR)
	mkdir -p $(BUILD_DIR)
	cp -al $(filter-out debian .git .svk .svn, $(wildcard .[^.]* *)) $(BUILD_DIR)
	# This applies the Bastian Blank patch to the Makefile to be able to
	# build without the Xen mercurial.
	# Sorry for this, I know this is unconventional, but it helps
	# doing easier backports to Lenny without the use of the quilt
	# format. If I am mistaking here, let me know how I should do.
	cd $(BUILD_DIR) \
		&& patch -p1 <../mypatches/add-rules.patch \
		&& patch -p1 <../mypatches/adds-audio-card-config.patch \
		&& patch -p1 <../mypatches/alsaaudio-spelling-mistake.patch \
		&& patch -p1 <../mypatches/remove-blktap.patch \
		&& patch -p1 <../mypatches/fix_buffer_underflow_CVE-2012-0029.patch \
	        && patch -p1 <../mypatches/xsa17-qemu-xen-traditional-all.patch \
		&& patch -p1 <../mypatches/xsa19-qemu-all.patch \
		&& patch -p1 <../mypatches/CVE-2012-6075-1 \
		&& patch -p1 <../mypatches/CVE-2012-6075-2
	touch $@

# The xen-setup thing
# Note that normally, --audio-drv-list supports to have all of these
# at the same time: oss alsa sdl esd pa
# and then, you can use an environment variable to select the driver
# like this: QEMU_AUDIO_DRV=pa
# There's also a list of emulated sound hardware that can be set in
# the soundhw= parameter of your guest, soundhw=ac97 being the best
# choice in terms of performances.
# --audio-card-list="ac97 es1370 sb16 cs4231a adlib gus"
$(STAMPS_DIR)/setup: $(STAMPS_DIR)/source
	cd $(BUILD_DIR); ./xen-setup \
		--audio-drv-list="pa oss alsa sdl esd" \
		--audio-card-list="ac97 es1370 sb16 cs4231a adlib gus" \
		--enable-mixemu
	touch $@

$(STAMPS_DIR)/build: $(STAMPS_DIR)/setup
	dh_testdir
	$(MAKE) -C $(BUILD_DIR) BUILD_DOCS=yes
	# As we don't want to conflict with the "normal" qemu-img utility, I
	# did this:
	mv $(BUILD_DIR)/qemu-img.1 $(BUILD_DIR)/qemu-img-xen.1
	# Remove blktap as support has been removed from the hypervisor
	#cd $(BUILD_DIR) && patch -p0 <../qemu-img-xen.1.diff
	touch $@

clean:
	dh_testdir
	dh_testroot
	dh_clean
	rm -rf $(BUILD_DIR) $(STAMPS_DIR)

$(STAMPS_DIR)/install: $(STAMPS_DIR)/build
	dh_testdir
	dh_testroot
	dh_prep
	# dh_installdirs
	# dh_link
	install -D -m 0755 $(BUILD_DIR)/i386-dm/qemu-dm debian/$(PKG_NAME)/usr/lib/$(XEN_TARGET)/bin/qemu-dm
	# Not shipping this, as it's in the qemu package
	#install -D -m 0755 $(BUILD_DIR)/qemu-img-xen debian/$(PKG_NAME)/usr/bin/qemu-img-xen
	install -D -m 0644 debian/docbase debian/$(PKG_NAME)/usr/share/doc-base/xen-qemu-dm-4.0-doc

	# $(MAKE) install DESTDIR=debian/$(PKG_NAME)$(XEN_FOLDER)

binary-arch: $(STAMPS_DIR)/install
	dh_testdir
	dh_testroot
	dh_installchangelogs Changelog
	dh_installdocs
	dh_link
	dh_shlibdeps
	dh_strip
	dh_fixperms
	dh_compress
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-indep: $(STAMPS_DIR)/install

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
http://www.xen.org/products/xen_source.html http://bits.xensource.com/oss-xen/release/(.*)/xen-(.*).tar.gz
